from openerp.osv import osv, fields
import os
from os import listdir
from os.path import isfile, join
import subprocess
import datetime
from datetime import datetime,timedelta
import shlex
#import spur
import ast
import json
import sys
import xml.etree.ElementTree as ET
import pdb
import logging
from collections import defaultdict
import getpass
import pytz
_logger = logging.getLogger(__name__)

class snapdeal_order_creation(osv.osv):

	_name = 'snapdeal.order.creation'

	FTP_SERVER = "ec2-54-251-85-20.ap-southeast-1.compute.amazonaws.com"
	FTP_USER = "root"
	FEED_LOCATION = "/home/snapdeal/Order_Feeds"
	PROCESSED_FEED_LOCATION = "/home/snapdeal/Processed_Order_Feeds"
	PREFIX = "SnapdealOrders"

	def getFeeds(self):																####returns the list of feeds in FEED_LOCATION
		user = getpass.getuser()
		shell = spur.SshShell(hostname=self.FTP_SERVER, username=self.FTP_USER, private_key_file="/home/%s/.ssh/id_rsa.pub" %(user), missing_host_key=spur.ssh.MissingHostKey.accept)
		with shell:
			result = shell.run(["ls", self.FEED_LOCATION])
			feeds = result.output.decode().split("\n")
		return feeds


	def moveFeed(self, feedName):
		user = getpass.getuser()
		shell = spur.SshShell(hostname=self.FTP_SERVER, username=self.FTP_USER, private_key_file="/home/%s/.ssh/id_rsa.pub" %(user), missing_host_key=spur.ssh.MissingHostKey.accept)
		with shell:
			shell.run(["cp", self.FEED_LOCATION+"/"+feedName, self.PROCESSED_FEED_LOCATION+"/"+feedName])


	def readFeed(self, feedName):
		user = getpass.getuser()
		shell = spur.SshShell(hostname=self.FTP_SERVER, username=self.FTP_USER, private_key_file="/home/%s/.ssh/id_rsa.pub" %(user), missing_host_key=spur.ssh.MissingHostKey.accept)
		with shell:
			result = shell.run(["cat", self.FEED_LOCATION+"/"+feedName])
			return result.output
		

	def get_order_details(self, cr, uid, lookback_time, context=None):
		details = {}

		feeds = self.getFeeds()
		if feeds == []:
			details["error"] = "No feed found"
		else:
			for feed in feeds:
				if feed.startswith("Snapdeal") == False:
					continue
				time = feed.split("SnapdealOrders",1)[1].split(".")[0]
				if time.startswith("Last3days"):
					time = time.split("Last3days")[1]
				t1 = fields.datetime.context_timestamp(cr, uid, datetime.now(), context={'tz':"Asia/Calcutta"}).replace(tzinfo=None)
				t2 = datetime.strptime(time,"%Y-%m-%d_%H:%M:%S")
				if (t1-t2) < timedelta(minutes=lookback_time):
					xmlString = self.readFeed(feed)											###Read the file remotely
					tempdetails = self.parse(xmlString)										###Get the order details dictionary generated by parse.py
					_logger.info(tempdetails)
					for key,value in tempdetails.items():										#For multiple feeds Check if its already in the hash. If yes, check status has changed
						if key in details:
							if value != details[key]:
								details[key] = value
						else:
							details[key] = value

					self.moveFeed(feed)
		return details

	def parse(self, xmlString):
		details = {}
		root = ET.fromstring(xmlString)

		for child in root:
			orderNum = child.find("OrderNum").text
			items = []
			details[orderNum] = {}
			suborders = child.find("SubOrders")
			orderStatus = "Confirmed"
			for suborder in suborders.findall("SubOrder"):
					temp = {}
					subordernum = suborder.find("SubOrderNumber").text
					temp["sub_order_id"] = subordernum
					sku = suborder.find("SKU").text
					temp["sku"] = sku
					quantity = suborder.find("Quantity").text
					temp["qty"] = quantity
					price = suborder.find("Price").text
					temp["sale_price"] = int(price)
					refCode = suborder.find("ReferenceCode").text
					temp["ref_code"] = refCode
					items.append(temp)
					status = suborder.find("Status").text
					if status == "Pending":
							orderStatus = "Pending"
					createdDate = suborder.find("CreatedDate").text
					verifiedDate = suborder.find("VerifiedDate").text
			email = child.find("EmailId").text
			if email is None:
				email = "NA"
			phone = child.find("MobileNum").text
			if phone is None:
				phone = "NA"
			add1 = child.find("Address1").text
			add2 = child.find("Address2").text
			city = child.find("City").text
			pin = child.find("Pincode").text
			state = child.find("State").text
			country = child.find("Country").text
			customer_name = child.find("CustomerName").text
			details[orderNum]["create_date"] = createdDate
			details[orderNum]["OrderNum"] = orderNum
			details[orderNum]["status"] = orderStatus
			details[orderNum]["line_items"] = items
			details[orderNum]["email"] = email
			details[orderNum]["phone"] = phone
			details[orderNum]["address_1"] = add1
			details[orderNum]["address_2"] = add2
			details[orderNum]["city"] = city
			details[orderNum]["postalCode"] = pin
			details[orderNum]["state"] = state
			details[orderNum]["country"] = country
			details[orderNum]["customer_name"] = customer_name
		return details

	def create_orders(self, cr, uid, lookback_time, context=None):
		order_creation_registry = self.pool.get("threep.order.creation")
		order_registry = self.pool.get('sale.order')
		source_registry = self.pool.get("crm.tracking.source")
		source_id = source_registry.search(cr, uid, [("name","=","Snapdeal")])
		if source_id:
			source_id = source_id[0]
		else:
			source_id = source_registry.create(cr, uid, {"name":"Snapdeal"})

		confirmed_order_query = cr.execute("select order_id from sale_order where write_date >= NOW() - '%s Hour'::INTERVAL and source_id=%s and status='confirmed'" %(lookback_time+6, source_id))
		confirmed_order_list = cr.fetchall()
		confirmed_orders = []
		for cot in confirmed_order_list:
			confirmed_orders.append(cot[0])
		# print confirmed_orders

		details = self.get_order_details(cr, uid, lookback_time)
		_logger.info(details)

		for order_id, order_details in details.iteritems():
			check_order = order_registry.search(cr, uid, [("order_id","=",order_id)])
			if not check_order:
				# ref_codes = [li["ref_code"] for li in order_details["line_items"]]
				ref_codes = list(set([x["ref_code"] for x in order_details["line_items"] if x["ref_code"]!= None]))
				check_order = order_registry.search(cr, 1, [("order_id", "in", ref_codes)])
				if check_order:
					continue
			if check_order:
				existing_order = order_registry.read(cr, uid, check_order[0], ["status", "order_line","partner_shipping_id","note"])
				if order_details["status"] == "Pending":
					continue
				elif existing_order["status"] == "confirmed":
					continue
				elif order_details["status"] == "Confirmed":
					address_hash = {}
					address_hash["ship_name"] = order_details["customer_name"]
					address_hash["ship_address"] = order_details["address_1"] + order_details["address_2"]
					address_hash["ship_zip_code"] = order_details["postalCode"]
					address_hash["country_code"] = order_details["country"]
					address_hash["state_name"] = order_details["state"]
					address_hash["ship_phone"] = order_details["phone"]
					address_hash["email"] = order_details["email"]

					create_date = order_details["create_date"]
					try:
						create_date = datetime.strptime(create_date, "%Y-%m-%d %H:%M:%S") - timedelta(hours=5, minutes=30)
					except:
						pass
					currency = "INR"
					shipping_type = "3rd_party"
					status = "confirmed"
					channel = "Snapdeal"

					items = order_details["line_items"]
					ref_codes = list(set([x["ref_code"] for x in items]))

					if len(ref_codes) == 1:
						order_update = {}
						order_update["order_id"] = ref_codes[0]
						order_update["status"] = "confirmed"
						order_registry.write(cr, uid, existing_order["id"], order_update)

					else:
						order_creation_registry.cancel_orders(cr, uid, check_order)
						dd = defaultdict(list)

						for item in items:
							dd[item["ref_code"]].append(item)

						for ref_code in ref_codes:
							line_items = []
							suborder_codes = []
							total_amount = 0.0

							for rc_item in dd[ref_code]:
								ol_item = {}
								ol_item["sku"] = rc_item["sku"]
								ol_item["qty"] = rc_item["qty"]
								ol_item["sale_price"] = rc_item["sale_price"]
								suborder_codes.append(rc_item["sub_order_id"])
								total_amount += rc_item["sale_price"]
								line_items.append(ol_item)

							order_creation_registry.create_orders(cr, uid, ref_code, line_items, address_hash, create_date, currency, shipping_type, status, channel, total_amount)
							# line_items = { req_key: dd[ref_code][req_key] for req_key in ["sku, quantity, sale_price"]}
			else:
				address_hash = {}
				address_hash["ship_name"] = order_details["customer_name"]
				address_hash["ship_address"] = order_details["address_1"] + order_details["address_2"]
				address_hash["ship_zip_code"] = order_details["postalCode"]
				address_hash["country_code"] = order_details["country"]
				address_hash["state_name"] = order_details["state"]
				address_hash["ship_phone"] = order_details["phone"]
				address_hash["email"] = order_details["email"]

				create_date = order_details["create_date"]
				try:
					create_date = datetime.strptime(create_date, "%Y-%m-%d %H:%M:%S") - timedelta(hours=5, minutes=30)
				except:
					pass
				#create_date = create_date.replace(tzinfo=pytz.timezone('Asia/Calcutta'))
				currency = "INR"
				shipping_type = "3rd_party"
				channel = "Snapdeal"

				status = order_details["status"]
				if status == "Pending":
					status = "not_confirmed"
				else:
					status = "confirmed"

				items = order_details["line_items"]
				ref_codes = list(set([x["ref_code"] for x in items if x["ref_code"]!= None]))

				if len(ref_codes) > 1:
					dd = defaultdict(list)

					for item in items:
						dd[item["ref_code"]].append(item)

					for ref_code in ref_codes:
						line_items = []
						suborder_codes = []
						total_amount = 0.0

						for rc_item in dd[ref_code]:
							ol_item = {}
							ol_item["sku"] = rc_item["sku"]
							ol_item["qty"] = rc_item["qty"]
							ol_item["sale_price"] = rc_item["sale_price"]
							suborder_codes.append(rc_item["sub_order_id"])
							total_amount += rc_item["sale_price"]
							line_items.append(ol_item)

						order_creation_registry.create_orders(cr, uid, ref_code, line_items, address_hash, create_date, currency, shipping_type, status, channel, total_amount)

				elif len(ref_codes) == 1:
					total_amount = sum(sp for sp in [ i["sale_price"] for i in items ])
					order_creation_registry.create_orders(cr, uid, ref_codes[0], items, address_hash, create_date, currency, shipping_type, status, channel, total_amount)

				else:
					order_num = order_details["OrderNum"]
					total_amount = sum(sp for sp in [ i["sale_price"] for i in items ])
					order_creation_registry.create_orders(cr, uid, order_num, items, address_hash, create_date, currency, shipping_type, status, channel, total_amount)
